(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 4.2'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     15720,        439]*)
(*NotebookOutlinePosition[     16459,        464]*)
(*  CellTagsIndexPosition[     16415,        460]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["Cache Tool", "Title"],

Cell["Junzo SATO", "Subtitle"],

Cell[BoxData[
    \(\(\( (*\ \(:\)\(Title : 
          CacheTool`\)*) \)\(\[IndentingNewLine]\)\( (*\ \(:\)\(Context : 
          CacheTool`\)*) \)\(\[IndentingNewLine]\)\( (*\ \(:\)\(Author : 
          Junzo\ SATO\)*) \)\(\[IndentingNewLine]\)\( (*\ \(:\)\(Summary : 
          Tools\ for\ accessing\ to\ the\ Post\ RDBMS\ \(\(Cache\)\(.\)\)\)\
*) \)\(\[IndentingNewLine]\)\( (*\ \(:\)\(Package\ \(Version : 
            1.0\)\)*) \)\(\[IndentingNewLine]\)\( (*\ \(:\)\(Release\ \(Note \
: July\ 2002\)\)*) \)\(\[IndentingNewLine]\)\( (*\ \(:\)\(Mathematica\ \
\(Version : 4.1\)\)*) \)\(\[IndentingNewLine]\)\( (*\ \(\(:\)\(Copyright : 
          Copyright\ \[Copyright]\ 2002\)\), 
      Junzo\ SATO . \ 
          All\ rights\ \(\(reserved\)\(.\)\)*) \)\(\[IndentingNewLine]\)\( \
(*\ \(:\)\(History : 
          Ver\ 1.0\ July\ 2002\ by\ Junzo\ \(\(SATO\)\(.\)\)\)*) \)\(\
\[IndentingNewLine]\)\( (*\ \(:\)\(Keywords : 
          Cache\)*) \)\(\[IndentingNewLine]\)\( (*\ \(:\)\(\(Reference\)\(:\)\
\)*) \)\(\[IndentingNewLine]\)\( (*\ \(:\)\(\(Limitation\)\(:\)\)*) \)\(\
\[IndentingNewLine]\)\( (*\ \(:\)\(\(Discussion\)\(:\)\)*) \)\)\)], "Input",
  InitializationCell->True],

Cell[CellGroupData[{

Cell["Begin Package", "Section"],

Cell[BoxData[
    \(BeginPackage["\<CacheTool`\>", {"\<JLink`\>", \
"\<Miscellaneous`Calendar`\>"}]\)], "Input",
  InitializationCell->True],

Cell["Unprotect[Evaluate[$Context<>\"*\"]]", "Text"],

Cell[BoxData[{
    \(\(NewObjectFactory::usage = "\<\>";\)\), "\[IndentingNewLine]", 
    \(\(GetFactoryInfo::usage = "\<\>";\)\)}], "Input",
  InitializationCell->True],

Cell[BoxData[{
    \(\(GetColumnName::usage = "\<\>";\)\), "\[IndentingNewLine]", 
    \(\(GetResultColumnsName::usage = "\<\>";\)\), "\[IndentingNewLine]", 
    \(\(ShowResult::usage = "\<\>";\)\), "\[IndentingNewLine]", 
    \(\(ExecuteSQL::usage = "\<\>";\)\), "\[IndentingNewLine]", 
    \(\(CountRecords::usage = "\<\>";\)\), "\[IndentingNewLine]", 
    \(\(PrintRecords::usage = "\<\>";\)\)}], "Input",
  InitializationCell->True],

Cell[BoxData[{
    \(\(ListResult::usage = "\<\>";\)\), "\[IndentingNewLine]", 
    \(\(ExecuteSQLAndListIt::usage = "\<\>";\)\)}], "Input",
  InitializationCell->True],

Cell[BoxData[{
    \(\(ToCacheDate::usage = "\<\>";\)\), "\[IndentingNewLine]", 
    \(\(FromCacheDate::usage = "\<\>";\)\)}], "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Begin", "Section"],

Cell[BoxData[
    \(Begin["\<`Private`\>"]\)], "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Setting Cache' Connection", "Section"],

Cell["\<\
This is the common tool to make connection with a namespace of Cache' data \
base.
CacheJava.jar and CacheJDBC.jar are needed.\
\>", "Text"],

Cell[BoxData[
    \(\(LoadClass["\<COM.intersys.objects.ObjectFactory\>"];\)\)], "Input",
  CellFrame->True,
  Background->GrayLevel[0.849989]],

Cell[BoxData[
    \(NewObjectFactory[\[IndentingNewLine]namespace_String: "\<USER\>", \
\[IndentingNewLine]port_Integer:  
          1972, \[IndentingNewLine]address_String: "\<127.0.0.1\>"] := 
      JavaNew["\<COM.intersys.objects.ObjectFactory\>", \
\[IndentingNewLine]StringJoin["\<cn_iptcp:\>", address, "\<[\>", 
          ToString[port], "\<]:\>", namespace]]\)], "Input",
  CellFrame->True,
  InitializationCell->True,
  Background->GrayLevel[0.849989]],

Cell[BoxData[
    \(GetFactoryInfo[f_] := 
      JavaBlock[
        Module[\[IndentingNewLine]{info}, \[IndentingNewLine]info = 
            f@getServerInfo[]; \[IndentingNewLine]{StringJoin["\<Connection \
-> \>", info@
                connectionInfo], \[IndentingNewLine]StringJoin["\<Cache' \
Version -> \>", info@objectsVersion], 
            StringJoin["\<Server Version -> \>", 
              info@serverVersion]}]]\)], "Input",
  CellFrame->True,
  InitializationCell->True,
  Background->GrayLevel[0.849989]],

Cell["We are going to access to the namespace \"FAIR21\".", "Text"],

Cell["factory=NewObjectFactory[\"FAIR21\"]", "Text"],

Cell[BoxData[
    \(factory = 
      NewObjectFactory["\<FAIR21\>", 1972, "\<133.95.89.130\>"]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(GetFactoryInfo[factory] // TableForm\)], "Input"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {"\<\"Connection -> cn_iptcp:127.0.0.1[1972]:FAIR21\"\>"},
          {"\<\"Cache' Version -> Cache for Windows NT (Intel) 4.0.3 (Build \
151U) Tue May 22 2001 10:42:10 EDT\"\>"},
          {"\<\"Server Version -> 4.0.0.381\"\>"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      TableForm[ {"Connection -> cn_iptcp:127.0.0.1[1972]:FAIR21", 
        "Cache' Version -> Cache for Windows NT (Intel) 4.0.3 (Build 151U) \
Tue May 22 2001 10:42:10 EDT", "Server Version -> 4.0.0.381"}]]], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Tools for Dynamic SQL", "Section"],

Cell[BoxData[
    \(Off[General::spell1]\)], "Input"],

Cell[BoxData[
    \(GetColumnName[col_] := col@name\)], "Input",
  CellFrame->True,
  InitializationCell->True,
  Background->GrayLevel[0.849989]],

Cell[BoxData[
    \(GetResultColumnsName[cols_] := 
      Module[\[IndentingNewLine]{l, i, s = "\<\>"}, \[IndentingNewLine]l = 
          Map[GetColumnName, cols]; \[IndentingNewLine]Do[
          s = StringJoin[s, "\<:\>", l[\([i]\)]], {i, 1, 
            Length[l]}]; \[IndentingNewLine]s = StringDrop[s, 1]]\)], "Input",\

  CellFrame->True,
  InitializationCell->True,
  Background->GrayLevel[0.849989]],

Cell[BoxData[{
    \(\(\(ShowResult[rs_] := 
      Module[\[IndentingNewLine]{cols, s = "\<\>", i, 
          rows = 0}, \[IndentingNewLine]cols = 
          rs@getColumns[]; \[IndentingNewLine]Print[
          GetResultColumnsName[cols]]; \[IndentingNewLine]While[
          rs@next[], \[IndentingNewLine]Do[
            s = StringJoin[s, "\<:\>", rs@getString[i]], {i, 1, 
              rs@getColumnCount[]}]; \[IndentingNewLine]If[
            StringLength[s] > 0, 
            s = StringDrop[s, 1]]; \[IndentingNewLine]Print[
            s]; \[IndentingNewLine]s = "\<\>"; \[IndentingNewLine]\(rows++\);\
\[IndentingNewLine]]; \[IndentingNewLine]Print["\<Printed \>", \ 
          rows, \ "\< \
row(s).\>"]\[IndentingNewLine]]\)\(\[IndentingNewLine]\)
    \)\), "\[IndentingNewLine]", 
    \(ShowResult[rs_, from_, to_] := 
      Module[\[IndentingNewLine]{cols, s = "\<\>", i, 
          rows = 0}, \[IndentingNewLine]cols = 
          rs@getColumns[]; \[IndentingNewLine]Print[
          GetResultColumnsName[cols]]; \[IndentingNewLine]While[
          rs@next[], \[IndentingNewLine]\(rows++\); \[IndentingNewLine]If[
            from \[LessEqual] rows \[LessEqual] to, \[IndentingNewLine]Do[
              s = StringJoin[s, "\<:\>", rs@getString[i]], {i, 1, 
                rs@getColumnCount[]}]; \[IndentingNewLine]If[
              StringLength[s] > 0, 
              s = StringDrop[s, 1]]; \[IndentingNewLine]Print[
              s]; \[IndentingNewLine]s = "\<\>", \[IndentingNewLine]Break[]\
\[IndentingNewLine]]\[IndentingNewLine]]; \[IndentingNewLine]Print["\<Printed \
\>", \ rows - 1, \ "\< row(s) from \>", from, "\< to \>", 
          to, "\<.\>"]\[IndentingNewLine]]\)}], "Input",
  CellFrame->True,
  InitializationCell->True,
  Background->GrayLevel[0.849989]],

Cell[BoxData[
    \(\(LoadClass["\<COM.intersys.objects.ResultSet\>"];\)\)], "Input",
  CellFrame->True,
  Background->GrayLevel[0.849989]],

Cell[BoxData[{
    \(ExecuteSQL[factory_, sql_] := 
      JavaBlock[
        Module[\[IndentingNewLine]{rs}, \[IndentingNewLine]rs = 
            JavaNew["\<COM.intersys.objects.ResultSet\>", factory, sql, 
              1]; \[IndentingNewLine]rs@
            execute[]; \[IndentingNewLine]ShowResult[
            rs]; \[IndentingNewLine]rs@
            close[]; \[IndentingNewLine]ReleaseObject[
            rs]\[IndentingNewLine]]]\[IndentingNewLine]\), "\
\[IndentingNewLine]", 
    \(ExecuteSQL[factory_, sql_, from_, to_] := 
      JavaBlock[
        Module[\[IndentingNewLine]{rs}, \[IndentingNewLine]rs = 
            JavaNew["\<COM.intersys.objects.ResultSet\>", factory, sql, 
              1]; \[IndentingNewLine]rs@
            execute[]; \[IndentingNewLine]ShowResult[rs, from, 
            to]; \[IndentingNewLine]rs@
            close[]; \[IndentingNewLine]ReleaseObject[
            rs]\[IndentingNewLine]]]\)}], "Input",
  CellFrame->True,
  InitializationCell->True,
  Background->GrayLevel[0.849989]],

Cell[BoxData[
    \(CountRecords[factory_, className_] := 
      JavaBlock[
        Module[\[IndentingNewLine]{sql, rs}, \[IndentingNewLine]sql = 
            StringJoin["\<SELECT COUNT(*) FROM \>", 
              className]; \[IndentingNewLine]ExecuteSQL[factory, 
            sql];\[IndentingNewLine]]]\)], "Input",
  CellFrame->True,
  InitializationCell->True,
  Background->GrayLevel[0.849989]],

Cell[BoxData[{
    \(\(\(PrintRecords[factory_, className_] := 
      JavaBlock[
        Module[\[IndentingNewLine]{sql, rs}, \[IndentingNewLine]sql = 
            StringJoin["\<SELECT * FROM \>", 
              className]; \[IndentingNewLine]ExecuteSQL[factory, 
            sql];\[IndentingNewLine]]]\)\(\[IndentingNewLine]\)
    \)\), "\[IndentingNewLine]", 
    \(PrintRecords[factory_, className_, from_, to_] := 
      JavaBlock[
        Module[\[IndentingNewLine]{sql, rs}, \[IndentingNewLine]sql = 
            StringJoin["\<SELECT * FROM \>", 
              className]; \[IndentingNewLine]ExecuteSQL[factory, sql, from, 
            to];\[IndentingNewLine]]]\)}], "Input",
  CellFrame->True,
  InitializationCell->True,
  Background->GrayLevel[0.849989]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Tools for Analysis", "Section"],

Cell[BoxData[{
    \(\(\(ListResult[rs_] := 
      Module[\[IndentingNewLine]{cols, l = {}, s = {}, i, 
          rows = 0}, \[IndentingNewLine]cols = 
          rs@getColumns[]; \[IndentingNewLine]l = 
          Append[l, Map[GetColumnName, cols]]; \[IndentingNewLine]While[
          rs@next[], \[IndentingNewLine]Do[
            s = Append[s, rs@getString[i]], \[IndentingNewLine]{i, 1, 
              rs@getColumnCount[]}]; \[IndentingNewLine]l = 
            Append[l, 
              s]; \[IndentingNewLine]s = {}; \[IndentingNewLine]\(rows++\);\
\[IndentingNewLine]]; \[IndentingNewLine]Return[
          l]\[IndentingNewLine]]\)\(\[IndentingNewLine]\)
    \)\), "\[IndentingNewLine]", 
    \(ListResult[rs_, from_, to_] := 
      Module[\[IndentingNewLine]{cols, l = {}, s = {}, i, 
          rows = 0}, \[IndentingNewLine]cols = 
          rs@getColumns[]; \[IndentingNewLine]l = 
          Append[l, Map[GetColumnName, cols]]; \[IndentingNewLine]While[
          rs@next[], \[IndentingNewLine]\(rows++\); \[IndentingNewLine]If[
            from \[LessEqual] rows \[LessEqual] to, \[IndentingNewLine]Do[
              s = Append[s, rs@getString[i]], \[IndentingNewLine]{i, 1, 
                rs@getColumnCount[]}]; \[IndentingNewLine]l = 
              Append[l, 
                s]; \[IndentingNewLine]s = {}, \[IndentingNewLine]Break[]\
\[IndentingNewLine]]\[IndentingNewLine]]; \[IndentingNewLine]Return[
          l]\[IndentingNewLine]]\)}], "Input",
  CellFrame->True,
  InitializationCell->True,
  Background->GrayLevel[0.849989]],

Cell[BoxData[
    \(\(LoadClass["\<COM.intersys.objects.ResultSet\>"];\)\)], "Input",
  CellFrame->True,
  Background->GrayLevel[0.849989]],

Cell[BoxData[{
    \(ExecuteSQLAndListIt[factory_, sql_] := 
      JavaBlock[
        Module[\[IndentingNewLine]{rs, l}, \[IndentingNewLine]rs = 
            JavaNew["\<COM.intersys.objects.ResultSet\>", factory, sql, 
              1]; \[IndentingNewLine]If[rs === $Failed, 
            Return[$Failed]]; \[IndentingNewLine]rs@
            execute[]; \[IndentingNewLine]l = 
            ListResult[rs]; \[IndentingNewLine]rs@
            close[]; \[IndentingNewLine]ReleaseObject[
            rs]; \[IndentingNewLine]Return[
            l]\[IndentingNewLine]]]\[IndentingNewLine]\), \
"\[IndentingNewLine]", 
    \(ExecuteSQLAndListIt[factory_, sql_, from_, to_] := 
      JavaBlock[
        Module[\[IndentingNewLine]{rs, l}, \[IndentingNewLine]rs = 
            JavaNew["\<COM.intersys.objects.ResultSet\>", factory, sql, 
              1]; \[IndentingNewLine]If[rs === $Failed, 
            Return[$Failed]]; \[IndentingNewLine]rs@
            execute[]; \[IndentingNewLine]l = 
            ListResult[rs, from, to]; \[IndentingNewLine]rs@
            close[]; \[IndentingNewLine]ReleaseObject[
            rs]; \[IndentingNewLine]Return[
            l]\[IndentingNewLine]]]\)}], "Input",
  CellFrame->True,
  InitializationCell->True,
  Background->GrayLevel[0.849989]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Tools for CacheDate", "Section"],

Cell[BoxData[
    \(<< Miscellaneous`Calendar`\)], "Input",
  CellFrame->True,
  Background->GrayLevel[0.849989]],

Cell[BoxData[
    \(ToCacheDate[y_, m_, d_] := 
      DaysBetween[{y, m, d}, {1840, 12, 31}]\)], "Input",
  CellFrame->True,
  InitializationCell->True,
  Background->GrayLevel[0.849989]],

Cell[BoxData[
    \(FromCacheDate[d_] := 
      Drop[ToDate[
          86400  d + FromDate[{1840, 12, 31, 0, 0, 0}]], \(-3\)]\)], "Input",
  CellFrame->True,
  InitializationCell->True,
  Background->GrayLevel[0.849989]],

Cell[CellGroupData[{

Cell[BoxData[
    \(FromCacheDate[52504]\)], "Input"],

Cell[BoxData[
    \({1984, 10, 1}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(ToCacheDate @@ %\)], "Input"],

Cell[BoxData[
    \(52504\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["End", "Section"],

Cell[BoxData[
    \(End[]\)], "Input",
  InitializationCell->True],

Cell["Protect[Evaluate[$Context<>\"*\"]]", "Text"],

Cell[BoxData[
    \(EndPackage[]\)], "Input",
  InitializationCell->True]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"4.2 for Microsoft Windows",
ScreenRectangle->{{0, 1024}, {0, 695}},
AutoGeneratedPackage->Automatic,
WindowSize->{841, 655},
WindowMargins->{{Automatic, 31}, {Automatic, 3}},
PrintingCopies->1,
PrintingPageRange->{Automatic, Automatic}
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 27, 0, 115, "Title"],
Cell[1806, 55, 30, 0, 64, "Subtitle"],
Cell[1839, 57, 1182, 19, 270, "Input",
  InitializationCell->True],

Cell[CellGroupData[{
Cell[3046, 80, 32, 0, 59, "Section"],
Cell[3081, 82, 140, 3, 30, "Input",
  InitializationCell->True],
Cell[3224, 87, 52, 0, 33, "Text"],
Cell[3279, 89, 169, 3, 50, "Input",
  InitializationCell->True],
Cell[3451, 94, 436, 7, 130, "Input",
  InitializationCell->True],
Cell[3890, 103, 168, 3, 50, "Input",
  InitializationCell->True],
Cell[4061, 108, 163, 3, 50, "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[4261, 116, 24, 0, 59, "Section"],
Cell[4288, 118, 83, 2, 30, "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[4408, 125, 44, 0, 59, "Section"],
Cell[4455, 127, 150, 4, 52, "Text"],
Cell[4608, 133, 143, 3, 46, "Input"],
Cell[4754, 138, 461, 9, 126, "Input",
  InitializationCell->True],
Cell[5218, 149, 516, 12, 146, "Input",
  InitializationCell->True],
Cell[5737, 163, 67, 0, 33, "Text"],
Cell[5807, 165, 52, 0, 33, "Text"],
Cell[5862, 167, 107, 2, 30, "Input"],

Cell[CellGroupData[{
Cell[5994, 173, 69, 1, 30, "Input"],
Cell[6066, 176, 637, 13, 57, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[6752, 195, 40, 0, 59, "Section"],
Cell[6795, 197, 53, 1, 30, "Input"],
Cell[6851, 200, 146, 4, 46, "Input",
  InitializationCell->True],
Cell[7000, 206, 407, 9, 126, "Input",
  InitializationCell->True],
Cell[7410, 217, 1781, 33, 626, "Input",
  InitializationCell->True],
Cell[9194, 252, 139, 3, 46, "Input"],
Cell[9336, 257, 1018, 22, 366, "Input",
  InitializationCell->True],
Cell[10357, 281, 399, 9, 126, "Input",
  InitializationCell->True],
Cell[10759, 292, 763, 16, 246, "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[11559, 313, 37, 0, 59, "Section"],
Cell[11599, 315, 1545, 29, 626, "Input",
  InitializationCell->True],
Cell[13147, 346, 139, 3, 46, "Input"],
Cell[13289, 351, 1274, 26, 446, "Input",
  InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{
Cell[14600, 382, 38, 0, 59, "Section"],
Cell[14641, 384, 113, 3, 46, "Input"],
Cell[14757, 389, 187, 5, 46, "Input",
  InitializationCell->True],
Cell[14947, 396, 220, 6, 46, "Input",
  InitializationCell->True],

Cell[CellGroupData[{
Cell[15192, 406, 53, 1, 30, "Input"],
Cell[15248, 409, 47, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[15332, 415, 49, 1, 30, "Input"],
Cell[15384, 418, 39, 1, 29, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[15472, 425, 22, 0, 59, "Section"],
Cell[15497, 427, 66, 2, 30, "Input",
  InitializationCell->True],
Cell[15566, 431, 50, 0, 33, "Text"],
Cell[15619, 433, 73, 2, 30, "Input",
  InitializationCell->True]
}, Open  ]]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

